#define NSTARSMAX 100 // maximum number of stars
#define NCMAX 2000    // maximum number of clouds
#define NHOLESMAX 100 // maximum number of holes
// Physical constants - note these are case sensitive!
// gkpi is defined in const.h
#define cspeed 3.0e10
#define kboltz 1.380658e-16
#define massh 1.6735e-24
#define msol 1.9891e33
#define rsol 6.96e10
#define lsol 3.8268e33
#define parsec 3.085678e18
#define yr 3.15569e7
#define gconstcgs 6.67259e-8
const int ntmax = 161; // number of cooling values in cooling function (=102 for JMP MEKAL, =161 for CW stitched K&I02/MEKAL curve)
/* Physical parameters */
#ifdef USER
int iqd, iqu0, iqe, iqk, iqeps, iqal0, iqie, delpart, iqpot;
float g, pfloor, dfloor, avisp, avise, tcond, sdiff, vis, ce1,
 ce2, cs, ct, cd, ce, ceps, kmin, epsmin, mtl, gconst, rat, heat, g1, 
  g2, g3, g4, g5, g6, g7, g8;
bool mon, fxp, inten;
FILE *monfile;
//JMP variables follow
bool monstats;          //turn on monitoring of statistics
bool mondsb;            //turn on dsb output at set time intervals
bool fractal;           //make cloud fractal
int ncoarse;            //number of cells per cloud radius to set the 
                        //lengthscale of the coarsest fractal structure
int nstars;             //actual number of stars
int remapcells;         //number of cells per remap radius (Multiple stars)
int ncellsmap;          //number of cells per remap radius (CW Binary stars)
int nholes;             //actual number of holes in SHELL_BLOWOUT
int pict_count;
int npd;                //no. of entries in temp dependent mu table
char coolcurve1[50],coolcurve2[50],prefx[30],cloudfilename[50];
float tfloor;
float rcloud;           //radius of cloud
float fracdim;          //fractal dimension of cloud
float be_massfrac;      //mass of cloud normalized to BE mass
float remap1,remap2;    // CWB (2 stars)
float rscale,uscale,rhoscale,pscale,tscale;
float mass[NSTARSMAX],mdot[NSTARSMAX],vinf[NSTARSMAX],tempw[NSTARSMAX],massfracx[NSTARSMAX],massfracy[NSTARSMAX],massfracz[NSTARSMAX],xpos[NSTARSMAX],ypos[NSTARSMAX],zpos[NSTARSMAX],xvel[NSTARSMAX],yvel[NSTARSMAX],zvel[NSTARSMAX];
float tmin,tmax,ramb,pamb,uamb,tamb,kamb,epsamb,xamb,yamb,zamb,muamb,avgmass,avgmassamb,avgmass1,avgmass2,eta,rob;
float tstats,timest,dphase_dsbwr_ap,t_dsbwr,timedsb;
float period,ecc,phase_offset,dsep;
float lamb_tot1[ntmax], lamb_tot2[ntmax], logt[ntmax], dlogt, gammaheat;
float pd[102],pdmu[102],pdg[102],pdh2[102],pdhi[102],pdhii[102],pdlogt[102],ied[102],pdmin,pdmax;
double te[ntmax],alpha[ntmax],y[ntmax],lambda[ntmax],loglambda[ntmax];
double t_min,t_max,logtmax,logtmin,t_ref,lambda_ref,fac;
bool initialsetup,first_radiate,cool,orbit,force,readinclouddata;
bool jmpidealizedcooling; //use JMP's idealized cooling curve
bool heating;             //heating turned on
bool clumpgmc;            //setup a high density GMC clump in a lower density medium
bool tempmu;              //use a temperature dependent mu
bool tempgamma;           //use a temperature dependent gamma
bool mov; //turn on movie output
float dumpt, dumpt2, dumpdt, dumpdt2;
//parameters relevant to cloud calculations
int ncc;             //actual number of clumps
float xc1[NCMAX] = {0.0, 0.0, 0.0, 0.0, 0.0};//store x,y,z coords of ncc clumps
float xc2[NCMAX] = {0.0, 0.0, 0.0, 0.0, 0.0};
float xc3[NCMAX] = {0.0, 0.0, 0.0, 0.0, 0.0};
float clr[NCMAX] = {1.0, 1.0, 1.0, 1.0, 1.0};//cloud radi
float cld[NCMAX] = {10.0,10.0,10.0,10.0,10.0};//cloud density contrasts
float clm[NCMAX] = {1.0, 1.0, 1.0, 1.0, 1.0};//cloud masses
float clmr[NCMAX] = {1.0, 1.0, 1.0, 1.0, 1.0};//cloud masses
float mach,chi,rhofudge,mcloud,vcloud,cld1,cld2; // cloud parameters
float shelldz,holedr,rshell,shockpos; // shell parameters
float hole_xpos[NHOLESMAX],hole_ypos[NHOLESMAX],hole_zpos[NHOLESMAX],hole_radius[NHOLESMAX];
float xcmin,xcmax,ycmin,ycmax,zcmin,zcmax,dc,rcmin,rcmax,chimin,chimax,massratio;
float slradius; //slab
float mdotcl,tinj,coolinj,coolamb; // clump parameters (steady mass injection)
//mdot = rate of mass injection per unit volume per unit time
//tinj = temperature of injected material
//coolinj = cooling rate of injected material
//coolamb = cooling rate of ambient material
int cust_al[4]; // Custom ind. clouds to "colour"
float fil_length,fil_rad,fil_theta,fil_phi,fil_com_x,fil_com_y,fil_com_z; // filament parameters
// SILO variables
bool image;
char silofile[SZNAM];
int cycle;
float idumpt, idumpdt;
#else
extern int iqd, iqu0, iqe, iqk, iqeps, iqal0, iqie, delpart, iqpot;
extern float g, pfloor, dfloor, tfloor, avisp, avise, tcond, sdiff, vis,
 ce1, ce2, cs, ct, cd, ce, ceps, kmin, epsmin, mtl, gconst, rat, heat,
  g1, g2, g3, g4, g5, g6, g7, g8;
extern bool mon, fxp, inten;
extern FILE *monfile;
//JMP variables follow
extern bool monstats,mondsb;
extern bool fractal;
extern int ncoarse;
extern int nstars; 
extern int remapcells;
extern int ncellsmap;
extern int nholes;             
extern int pict_count;
extern int npd;
extern char coolcurve1[50],coolcurve2[50],prefx[30],cloudfilename[50];
extern float remap1,remap2;
extern float rcloud, fracdim, be_massfrac;
extern float rscale,uscale,rhoscale,pscale,tscale;
extern float mass[NSTARSMAX],mdot[NSTARSMAX],vinf[NSTARSMAX],tempw[NSTARSMAX],massfracx[NSTARSMAX],massfracy[NSTARSMAX],massfracz[NSTARSMAX],xpos[NSTARSMAX],ypos[NSTARSMAX],zpos[NSTARSMAX],xvel[NSTARSMAX],yvel[NSTARSMAX],zvel[NSTARSMAX];
extern float tmin,tmax,ramb,pamb,uamb,tamb,kamb,epsamb,xamb,yamb,zamb,muamb,avgmass,avgmassamb,avgmass1,avgmass2,eta,rob;
extern float tstats,timest,dphase_dsbwr_ap,t_dsbwr,timedsb;
extern float period,ecc,phase_offset,dsep;
extern float lamb_tot1[ntmax], lamb_tot2[ntmax], logt[ntmax], dlogt, gammaheat;
extern float pd[102],pdmu[102],pdg[102],pdh2[102],pdhi[102],pdhii[102],pdlogt[102],ied[102],pdmin,pdmax;
extern double te[ntmax],alpha[ntmax],y[ntmax],lambda[ntmax],loglambda[ntmax];
extern double t_min,t_max,logtmax,logtmin,t_ref,lambda_ref,fac;
extern bool initialsetup,first_radiate,cool,orbit,force,readinclouddata;
extern bool jmpidealizedcooling,heating,clumpgmc,tempmu,tempgamma;
extern bool mov; //turn on movie output
extern float dumpt, dumpt2, dumpdt, dumpdt2;
extern int ncc;
extern float xc1[NCMAX],xc2[NCMAX],xc3[NCMAX],clr[NCMAX],cld[NCMAX],clm[NCMAX],clmr[NCMAX];
extern float mach,chi,rhofudge,mcloud,vcloud,cld1,cld2;
extern float shelldz,holedr,rshell,shockpos; 
extern float hole_xpos[NHOLESMAX],hole_ypos[NHOLESMAX],hole_zpos[NHOLESMAX],hole_radius[NHOLESMAX];
extern float xcmin,xcmax,ycmin,ycmax,zcmin,zcmax,dc,rcmin,rcmax,chimin,chimax,massratio;
extern float mdotcl,tinj,coolinj,coolamb;
extern int cust_al[4]; // Custom ind. clouds to "colour"
extern float fil_length,fil_rad,fil_theta,fil_phi,fil_com_x,fil_com_y,fil_com_z; // filament parameters
// SILO variables
extern bool image;
extern char silofile[SZNAM];
extern int cycle;
extern float idumpt, idumpdt;
#endif
